#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <qdos.h>
#include <ctype.h>
#include <qptr.h>

extern char jg_br,jg_bl,jg_tr,jg_tl;
extern struct WM_sprite sp_t0,sp_t1,sp_t2,sp_t3,sp_t4,sp_t5,sp_t6,sp_t7;
extern struct WM_sprite sp_g0,sp_g1,sp_g2,sp_g3,sp_g4,sp_g5,sp_g6,sp_g7;
extern struct WM_sprite sp_d0,sp_d1,sp_d2,sp_d3,sp_d4,sp_d5,sp_d6,sp_d7;
extern struct WM_sprite sp_c0,sp_c1,sp_c2,sp_c3,sp_c4,sp_c5,sp_c6,sp_c7;
extern struct WM_sprite sp_ball0,sp_heros0;
extern struct WM_sprite sp_ball1,sp_heros1;
extern struct WM_sprite sp_ball2,sp_heros2;
extern struct WM_sprite sp_ball3,sp_heros3;
extern struct WM_sprite sp_ball4,sp_heros4;
extern struct WM_sprite sp_ball5,sp_heros5;
extern struct WM_sprite sp_ball6,sp_heros6;
extern struct WM_sprite sp_ball7,sp_heros7;
extern struct WM_sprite sp_serp0,sp_serp1,sp_serp2,sp_serp3,sp_serp4,sp_serp5,sp_serp6,sp_serp7;


struct WINDOWDEF _condetails = 
                    { (char) 0,(char) 0,(char)0,(char)7,
                      (short)1024,(short)512,(short)0,(short)0};


int high=5000;
long score=0,lscore=0,lives=3,level=0;
char scr[13][15],s[46];
long cols[5],kugpos[15][2];
long chan,mancol,ballcol;
char mcol,mnlin,mconts,kcol,klin,kconts,slin,scol,sconts;
long fcols3,fcols2,fcols1;
long maxp,mpcount,bon,maxc;
long mstartlin,mstartcol,maxpos,hassnake,snakcol,sstartlin,sstartcol;
char _conname[] = "con_1024x512a0x0";
char *_endmsg  = NULL;                /* and stop when I say */

char _PROG_NAME[] = "Q*Bert";

void sound(char st,char nd)
{
char i;
for(i=st;((i<nd)&&(st<nd))||((i>nd)&&(nd<st));i+=(st>nd)?-1:1)
    {
    beep(1000,i); mt_susjb(-1,2,0);
    }
}


struct WM_sprite *top(char c)
{
switch(c)
{
case 0: return &sp_t0; break;
case 1: return &sp_t1; break;
case 2: return &sp_t2; break;
case 3: return &sp_t3; break;
case 4: return &sp_t4; break;
case 5: return &sp_t5; break;
case 6: return &sp_t6; break;
case 7:
default:
  return &sp_t7; break;
}
}

struct WM_sprite *droite(char c)
{
switch(c)
{
case 0: return &sp_d0; break;
case 1: return &sp_d1; break;
case 2: return &sp_d2; break;
case 3: return &sp_d3; break;
case 4: return &sp_d4; break;
case 5: return &sp_d5; break;
case 6: return &sp_d6; break;
case 7:
default:
  return &sp_d7; break;
}
}

struct WM_sprite *couleur(char c)
{
switch(c)
{
case 0: return &sp_c0; break;
case 1: return &sp_c1; break;
case 2: return &sp_c2; break;
case 3: return &sp_c3; break;
case 4: return &sp_c4; break;
case 5: return &sp_c5; break;
case 6: return &sp_c6; break;
case 7:
default:
  return &sp_c7; break;
}
}

struct WM_sprite *gauche(char c)
{
switch(c)
{
case 0: return &sp_g0; break;
case 1: return &sp_g1; break;
case 2: return &sp_g2; break;
case 3: return &sp_g3; break;
case 4: return &sp_g4; break;
case 5: return &sp_g5; break;
case 6: return &sp_g6; break;
case 7:
default:
  return &sp_g7; break;
}
}

struct WM_sprite *man(char c)
{
switch(c)
{
case 0: return &sp_heros0; break;
case 1: return &sp_heros1; break;
case 2: return &sp_heros2; break;
case 3: return &sp_heros3; break;
case 4: return &sp_heros4; break;
case 5: return &sp_heros5; break;
case 6: return &sp_heros6; break;
case 7:
default:
  return &sp_heros7; break;
}
}

struct WM_sprite *snake(char c)
{
switch(c)
{
case 0: return &sp_serp0; break;
case 1: return &sp_serp1; break;
case 2: return &sp_serp2; break;
case 3: return &sp_serp3; break;
case 4: return &sp_serp4; break;
case 5: return &sp_serp5; break;
case 6: return &sp_serp6; break;
case 7:
default:
  return &sp_serp7; break;
}
}

struct WM_sprite *ball(char c)
{
switch(c)
{
case 0: return &sp_ball0; break;
case 1: return &sp_ball1; break;
case 2: return &sp_ball2; break;
case 3: return &sp_ball3; break;
case 4: return &sp_ball4; break;
case 5: return &sp_ball5; break;
case 6: return &sp_ball6; break;
case 7:
default:
  return &sp_ball7; break;
}
}

#define Xpos(c,l) (-64+(c)*64-((l) % 2)*32 )
#define Ypos(c,l) (32+(l)*28)

void remove_fig(char l,char c,char s)
{
short x,y;
x=Xpos(c,l-1);
y=Ypos(c,l-1);
if (!(l%2)) {iop_wspt(chan,-1,x,y,droite(scr[l-1][c]?fcols2:0));
x=Xpos(c+1,l-1);
y=Ypos(c+1,l-1);
iop_wspt(chan,-1,x,y,gauche(scr[l-1][c+1]?fcols1:0));
}
else {
iop_wspt(chan,-1,x,y,gauche(scr[l-1][c]?fcols1:0));/* 1 */
x= Xpos(c-1,l-1);
y= Ypos(c-1,l-1);
iop_wspt(chan,-1,x,y,droite(scr[l-1][c-1]?fcols2:0));
}
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,top(scr[l][c]?fcols3:0));
if ( (scr[l][c]) &&
   (cols[s?(s==1?kconts:sconts):mconts]!= fcols3)
   )
 {
 iop_wspt(chan,-1,x,y,couleur(cols[s?(s==1?kconts:sconts):mconts]));
 }
}

void felt(char l,char c)
{
short x,y;
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,droite(fcols2));
iop_wspt(chan,-1,x,y,gauche(fcols1));
iop_wspt(chan,-1,x,y,top(fcols3));
}

void figure_man(char l,char c)
{
short x,y;
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,man(mancol));
}

void figure_snake(char l,char c)
{
short x,y;
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,snake(snakcol));

}

void figure_ball(char l,char c)
{
short x,y;
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,ball(ballcol));
}


void figure_base(char l,char c,char col)
{
short x,y;
x= Xpos(c,l);
y= Ypos(c,l);
iop_wspt(chan,-1,x,y,couleur(col));
}

void print_scores()
{
char s[20];
sprintf(s,"%d ",score);

sd_pos(chan,-1,16-strlen(s),0);
io_sstrg(chan,-1,s,strlen(s));
sprintf(s,"%d ",high);

sd_pos(chan,-1,32-strlen(s),0);
io_sstrg(chan,-1,s,strlen(s));

}

void print_level_etc()
{
char s[20];
sprintf(s,"LEVEL:%2.2d ",level);

sd_pos(chan,-1,3,21);
io_sstrg(chan,-1,s,strlen(s));
sprintf(s,"LIVES:%d ",lives);

sd_pos(chan,-1,27,21);
io_sstrg(chan,-1,s,strlen(s));
sd_pos(chan,-1,0,0);
}

void init_positioner()
{
char rv;
mnlin=mstartlin;
mcol=mstartcol;
mconts=scr[mnlin][mcol];
scr[mnlin][mcol]=-1;
figure_man(mnlin,mcol);
if (maxpos){
rv=rand()%maxpos;
klin=kugpos[rv][0];
kcol=kugpos[rv][1];
kconts=scr[klin][kcol];
scr[klin][kcol]=-2;
figure_ball(klin,kcol);
}
if (hassnake){
slin=sstartlin;
scol=sstartcol;
sconts=scr[slin][scol];
scr[slin][scol]=-3;
figure_snake(slin,scol);
}
}
void testscore()
{
if (score-lscore<10000) return;
lscore=score;
lives+=1;
return;
}

void bonus(long value)
{
char i,n;
char s[20];
sprintf(s,"Bonus:%d ",value);
sd_setmd(chan,-1,DM_OR);
for(i=1;i<21;i++)
for(n=0;n<8;n++)
{
sd_setin(chan,-1,(int)n);
sd_setsz(chan,-1,3,1);
sd_pos(chan,-1,(short)13,(short)10);
sd_setsz(chan,-1,3,1);
io_sstrg(chan,-1, s,strlen(s));
}
sd_setin(chan,-1,7);
sd_setsz(chan,-1,3,1);
sd_setmd(chan,-1,DM_OVER);
score+=value;
testscore();
sound(50,30);
sound(45,15);
}

void init_level(FILE *fd)
{
char i,j,k;
long grad_y,pitch,wor;
sd_clear(chan,-1);
for(i=1;i<=100;i++)
{
beep(100,(2*i)%20);
sd_setin(chan,-1,i);
sd_ipoint(chan,-1,rand()%200,rand()%100);
}
sd_setin(chan,-1,7);
sd_pos(chan,-1,5,0);
sprintf(s,"SCORE:00000");
io_sstrg(chan,-1,s,strlen(s));
sprintf(s,"HIGH:00000");
sd_pos(chan,-1,22,0);
io_sstrg(chan,-1,s,strlen(s));
sprintf(s,"BONUS:0");
sd_pos(chan,-1,14,21);
io_sstrg(chan,-1,s,strlen(s));
print_scores();
print_level_etc();
fscanf(fd,"%d,%d,%d,",&maxp,&bon,&maxc);
if (feof(fd))
{
sound (80,10);
sound (40,10);
sound (30,10);
sound (20,10);
bonus(level*100);
fseek(fd,0,SEEK_SET);
fscanf(fd,"%d,%d,%d,",&maxp,&bon,&maxc);
} /* end eof */
mpcount=0;
sprintf(s,"BONUS:%d",bon);
sd_pos(chan,-1,14,21);
io_sstrg(chan,-1,s,strlen(s));
for(k=0;k<maxc;k++)
{
fscanf(fd,"%d,",&cols[k+1]);
}
cols[0]=0;
fscanf(fd,"%d,%d,%d,",&fcols1,&fcols2,&fcols3);
cols[maxc+1]=fcols3;
grad_y=2+rand()%6;
pitch=rand()%46;
for(i=2;i<=11;i++)
{
fscanf(fd,"%d,",&wor);
for(j=3;j<=14;j++)
    {
    scr[i][j]=((wor>>(j-3)) & (1))?(maxc+1):0; /* 13 x 15 */
    if (scr[i][j])
        {
        do_sound(1000,20+50/i,pitch,0,grad_y,0,0,0);
        felt(i,j);
        mt_susjb(-1,3,0);
        }
    }
}
fscanf(fd,"%d,",&maxpos);
for(i=0;i<maxpos;i++)
{
fscanf(fd,"%d,%d,",&kugpos[i][0],&kugpos[i][1]);
}
fscanf(fd,"%d,%d",&mstartlin,&mstartcol);
fscanf(fd,",%d,%d",&ballcol,&mancol);
fscanf(fd,",%d,%d,%d,%d",&hassnake,&snakcol,&sstartlin,&sstartcol);
init_positioner();
}

void man_dead()
{
long i;
char k;
for(i=1;i<=255;i+=3) {beep(2000,i);mt_susjb(-1,1,0);}
lives-=1;print_level_etc();
if (maxpos) remove_fig(klin,kcol,1);
if (hassnake) remove_fig(slin,scol,2);
remove_fig(mnlin,mcol,0);
while(!io_fbyte(chan,5,&k)); /* purge keyboard queue */
init_positioner();
}


move_ball()
{
char rv;
remove_fig(klin,kcol,1);
scr[klin][kcol]=kconts;
klin+=1;
rv=rand()%2;
kcol+=rv-((klin+1) % 2);
kconts=scr[klin][kcol];
if (kconts==0) {kcol+=(rv==1)?-1:1;}
kconts=scr[klin][kcol];
if (kconts==0) {rv=rand()%maxpos; klin=kugpos[rv][0];kcol=kugpos[rv][1];
kconts=scr[klin][kcol];}
scr[klin][kcol]=-2; figure_ball(klin,kcol);
if (!hassnake) do_sound(1000,0,0,-1,0,0,0,0);
/* mt_susjb(-1,20,0); */
}


move_snake()
{
static char rv=0;
char oslin,oscol;
remove_fig(slin,scol,2);
scr[slin][scol]=sconts;
oslin=slin;oscol=scol;
do{
if ((rand()%3)==0) {rv=rand()%4;}
slin+=(rv<2)?1:-1;
scol+=(rv%2)-((slin+1) % 2);
sconts=scr[slin][scol];
if (sconts==0) {scol=oscol;slin=oslin;}
} while(!sconts);
scr[slin][scol]=-3; figure_snake(slin,scol);
do_sound(1000,0,0,-1,0,0,0,0);
}


move_man()
{
short x=-1,y=-1;
char term=1;
char kstk;
figure_man(mnlin,mcol);

/* iop_rptr(chan,50,&x,&y,term,&windo); */
kstk=0;
if (!io_fbyte(chan,30,&kstk)){
kstk=toupper(kstk); /* upper & lower go upper */
if ((kstk==jg_bl)||(kstk==jg_br)||(kstk==jg_tl)||(kstk==jg_tr))
{
 remove_fig(mnlin,mcol,0);
 scr[mnlin][mcol]=mconts;
 mnlin += ((kstk==jg_bl)||(kstk==jg_br))?1:-1;
 mcol += (((kstk==jg_tr)||(kstk==jg_br))?1:0)-((mnlin+1)%2) ;
 beep(200,200);
 mconts=scr[mnlin][mcol];
 scr[mnlin][mcol]=-1;
 if (mconts>1) {
score+= (12-mnlin);
testscore();
mconts-=1;
mpcount+=1;
figure_base(mnlin,mcol,cols[mconts]);
}
figure_man(mnlin,mcol);
}
}
}

void snake_dead()
{
if (!hassnake) {lives+=1; /* you survive the snake */
print_level_etc();}
sound(40,60);
}

void main()
{
short s_mode=-1,d_type=-1;
FILE *fd;
char *dir;
char mai,lev,pla;


mt_dmode(&s_mode,&d_type);
if (s_mode < 9)
    {
    exit(-19);
    }
srand(time(0));

chan=io_open("con_896x440a64x32",2);
sd_setsz(chan,-1,3,1);

if (dir=getenv("QLBERT"))
    {
    chdir(dir);
    }
fd=fopen("qlbert_dat","r");
if (!fd) {printf("Let's me found the QLBERT_DAT file in the data_directory\n");
printf("\nOr set the QLBERT environment variable to the good directory\n");
mt_susjb(-1,2000,0); exit(0);}
for(mai=1;mai;) /* main loop */
{
lscore=0;lives=3;score=0;level=0;
fseek(fd,0,SEEK_SET);
for(lev=1;lev;)
{
level++;
if (feof(fd))
{
sound (80,10);
sound (40,10);
sound (30,10);
sound (20,10);
bonus(level*100);
fseek(fd,0,SEEK_SET);
} /* end eof */
init_level(fd);
sound(60,30); sound(40,10);
for(pla=1;pla;)
{
move_man();
if ((mconts==-2)||(mconts==0)||(mconts==-3))
    {
    scr[mnlin][mcol]=mconts;
    if (maxpos && (kconts>=0)) scr[klin][kcol]=kconts;
    if (hassnake && (sconts>=0)) scr[slin][scol]=sconts;
    man_dead();
    if (lives==0) {lev=0; pla=0;}
    }
else
{
sprintf(s,"%d",score);
sd_pos(chan,-1,16-strlen(s),0);
io_sstrg(chan,-1,s,strlen(s));
if (maxp==mpcount)
{
score+=bon;
testscore();
pla=0;
}  /* else maxp */
else
{
if (bon) {
bon-=10;
sprintf(s,"%d ",bon);
sd_pos(chan,-1,20,21);
io_sstrg(chan,-1,s,strlen(s));
sd_pos(chan,-1,1,0);
}   /* end if bon */
if (maxpos) {move_ball();
if (kconts==-1)
{
scr[mnlin][mcol]=mconts;
if (hassnake && (sconts>=0)) scr[slin][scol]=sconts;
    man_dead();
if (lives==0) {pla=0; lev=0;}
}  /* end if kconts */
if (kconts==-3) /* kill the snake */
{
kconts=sconts;
hassnake-= 1; /* he's dead, jim */
snake_dead();
}
} /* end if maxpos */
if (hassnake)
{ move_snake();
if (sconts==-1)
{
scr[mnlin][mcol]=mconts;
if (maxpos && (kconts>=0)) scr[klin][kcol]=kconts;
    man_dead();
if (lives==0) {pla=0; lev=0;}
}
if (sconts==-2)
{
hassnake-= 1; /* he's dead, jim */
snake_dead();
} /* end scont */
} /* end hasnask */
} /* endif maxp */
} /* end if mconts */
} /* end pla */
if (lev==1)
{
sound(50,15);
}
} /* end lev */
sound(10,50);
sound(40,100);
sound(90,110);
if (score>high) {high=score;print_scores(score,high);}
io_fbyte(chan,50,&pla);

for(pla=1;pla;) /* floop */
{
char n;
short x=-1,y=-1;
char term=3;
char kstk;
sprintf(s,"GAME OVER");
sd_setmd(chan,-1,DM_OR);
sd_setsz(chan,-1,3,1);
for(n=0;n<8;n++)
{
sd_setin(chan,-1,(int)n);
sd_pos(chan,-1,(short)20,(short)10);
sd_setsz(chan,-1,3,1);
io_sstrg(chan,-1, s,strlen(s));
/* iop_rptr(chan,50,&x,&y,term,&windo); */
kstk=0;
io_fbyte(chan,1,&kstk);

if (kstk>31) {pla=0;n=9;}
} /* end for n */
sd_setmd(chan,-1,DM_OVER);
sd_setsz(chan,-1,3,1);
sd_pos(chan,-1,(short)20,(short)10);
} /* end pla */
}/* end mai */

}
